#include <dos.h>

volatile char keystatus[256];
volatile unsigned char readch, oldreadch, extended;

static void (__interrupt __far *oldkeyhandler)();
static void __interrupt __far keyhandler(void);

#pragma aux interruptend =\
   "mov al, 20h",\
   "out 20h, al",\
   modify [eax]\

#pragma aux readkey =\
   "in al, 0x60",\
   "mov readch, al",\
   "in al, 0x61",\
   "or al, 0x80",\
   "out 0x61, al",\
   "and al, 0x7f",\
   "out 0x61, al",\
   modify [eax]\

void __interrupt __far keyhandler()
{
   oldreadch = readch;
   readkey();
   if ((readch|1) == 0xe1)
      extended = 128;
   else
   {
      if (oldreadch != readch)
         keystatus[(readch&127)+extended] = ((readch>>7)^1);
      extended = 0;
   }
   interruptend();
}
   
main()   
{
   long i, count, oldcount;
   
   oldkeyhandler = _dos_getvect(0x9);
   _disable(); _dos_setvect(0x9, keyhandler); _enable();
   for(i=0;i<256;i++)
      keystatus[i] = 0;
   count = 0;
   while (keystatus[1] == 0)
   {
      oldcount = count;
      count = 0;
      for(i=0;i<256;i++)
         if (keystatus[i] > 0)
            count += i;
      if ((count != oldcount) && (count > 0))
      {
         for(i=0;i<256;i++)
            if (keystatus[i] > 0)
               printf("%x ",i);
         printf("\n");
      }
   }
   _disable(); _dos_setvect(0x9, oldkeyhandler); _enable();
}
